#!/bin/sh
#update_last时设置版本eg：F17.2_ad1
BASE_VERSION="F23.2_ad0"
#update_last时设置版本eg：20170715
PATCH_VERSION="20240228"
HIBERNATE_FILE=/WEB-INF/classes/hibernate.properties
UPDATE_PATH=/usr/local/fuwushe
LOG_DIR=/var/fuwushe/log/update

log_msg_file() {
	#判断函数参数个数 
	if [ $# -lt 2 ] ; then                  
		return          
	fi
	
	path=$LOG_DIR/$1
	if [ ! -d $path ]; then
		mkdir -p $path
	fi
	
	packagelog=$path/$2.log
}

# 必须先调用log_msg_file设置日志文件
log_msg() {
	declare i
#判断函数参数个数 
	if [ $# -lt 1 ] ; then                  
		return          
	fi

	for i
	do
		echo $i >> $packagelog
	done
}

update_sys(){
	#database
	read -p "Please input MySQL root password:" mysqlpwd
	cd ..
	setup_path=`pwd`
	
	cd $setup_path
		
	$setup_path/tomcat/bin/shutdown.sh
		
	cd update/
	$setup_path/mysql/bin/mysql -uroot -p$mysqlpwd < update.sql --default-character-set=utf8
	
	#更新文件
	/bin/cp -a tomcat/ $setup_path/
	rm -rf $setup_path/tomcat/work	
	$setup_path/tomcat/bin/startup.sh
}

update_sys_user(){
	#database
	read -p "Please input MySQL USER password:" mysqluser
	read -p "Please input MySQL $mysqluser password:" mysqlpwd
	cd ..
	setup_path=`pwd`
	
	cd $setup_path
		
	$setup_path/tomcat/bin/shutdown.sh
		
	cd update/
  $setup_path/mysql/bin/mysql -u$mysqluser -p$mysqlpwd < update.sql --default-character-set=utf8
	
	#更新文件
	/bin/cp -a tomcat/ $setup_path/
	rm -rf $setup_path/tomcat/work	
	$setup_path/tomcat/bin/startup.sh
}

update_pwd(){
	read -p "Please input MySQL ROOT password:" mysqlpwd
	cd ..
	setup_path=`pwd`
	
	cd $setup_path
		
	$setup_path/tomcat/bin/shutdown.sh
	
	
}

do_update(){
	mysqlpwd=`cat $UPDATE_PATH/tomcat/webapps/cc/$HIBERNATE_FILE |grep password|awk -F '=' '{print $2}'`
	log_msg "db password: $mysqlpwd"
	
	sql="select CurentVersion from stfoa.sysadmin_tbl_product where Id=1;"
	version=`$UPDATE_PATH/mysql/bin/mysql -uroot -p$mysqlpwd -e "$sql" | awk 'NR>1'`
	log_msg "current version: $version"

	patch=`$UPDATE_PATH/mysql/bin/mysql -uroot -p$mysqlpwd -e "select PatchVersion from stfoa.sysadmin_tbl_product where Id=1;"|tail -n +2`
	log_msg "current patch :"$patch
	if [ "$BASE_VERSION" != "" ];then
		if [ "$BASE_VERSION" != "$version" ];then
			log_msg "ERROR:This version can not be updated with this additional update"
			exit 1;
		else 
			#patch="20151220"
			#update_time=`$UPDATE_PATH/mysql/bin/mysql -uroot -p$mysqlpwd -e "select UpdateTime from stfoa.sysadmin_tbl_product where Id=1;"|tail -n +2`;
				new_patch=$PATCH_VERSION
				old_patch=$patch
				log_msg "new_patch $new_patch"
				log_msg "old_patch $old_patch"
		 		if [ $old_patch -ge $new_patch ];then
						log_msg "ERROR: Have done this additional update, do not need to repeat the update"
						exit 2;
				fi		
		fi
	fi
	
	$UPDATE_PATH/tomcat/bin/shutdown.sh
		
	cd $UPDATE_PATH/update/
  $UPDATE_PATH/mysql/bin/mysql -uroot -p$mysqlpwd < update.sql --default-character-set=utf8
	log_msg "INFO:import update.sql $?"
	#更新文件
	/bin/cp -a tomcat/ $UPDATE_PATH/
	log_msg "INFO:cp update file $?"
	rm -rf $UPDATE_PATH/tomcat/work	
	log_msg "INFO: start tomcat"
	$UPDATE_PATH/tomcat/bin/startup.sh
	
	if [ "$?" == "0" ]; then
		log_msg "INFO: update successfully"
	fi
}

date=`date +%Y%m%d%H%M%S`

if [ "$1" == '' ] ; then
	PACKAGE_NAME=all_`date +%Y%m%d`
else
	PACKAGE_NAME=$BASE_VERSION_`date +%Y%m%d`
fi

log_msg_file $PACKAGE_NAME $date

case $1 in
	--update|-u)
		update_sys
		exit $?
	;;
	--update_by_user|-uu)
		update_sys
		exit $?
	;;
	--patch|-p)
		do_update
		exit $?
	;;
	*)
		do_update
	;;
esac